﻿/*
Developed by Kristin Henry (galaxygoo@gmail.com)
This code is available as is, without warranty.

www.underground-flash.com
www.underground-lab.com
August 2008
*/

package {
	
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	
	
	public class Box extends MovieClip{
		
		// properties
		//-------------------------------------------------------------------------
		public var xMax;
		public var yMax;
		private var targ;
		private var gen;
		
		private var boxes:Sprite = new Sprite();
		private var icons:Array = new Array();
		
		private var n; 
		private var startX;
		private var startY;
		private var W;
		private var H;
		private var w1;
		private var h1;
		private var w2;
		private var h2;
		private var midW;
		private var midH;
		
		private var myTimer:Timer;
		private var myTimer2:Timer = new Timer(60, 0);;
		private var tCount:Number = 0;
		
		private var mom; 
		public var maxCells:Number;
		public var dropCount;
		private var restart_btn;
		
		// contstuctor
		//-------------------------------------------------------------------------
		public function Box(target){
			
			gen = 0;
			dropCount = 0;
			w1 = 100;//50;
			
			targ = target;
			W = target.width;
			H = target.height;
			startX = target.x;
			startY = target.y;
			
			midW = getMidX();
			midH = getMidY();
			
			xMax = W;
			yMax = H;
		}
		
				
		// functions
		//-------------------------------------------------------------------------
				
		public function addLines(){
			
			// draw lines over time
			myTimer = new Timer(60, 0);
			myTimer.addEventListener(TimerEvent.TIMER, controller);
			myTimer.start();
		}
				
		function controller(event:TimerEvent):void{		
		
			var a = boxes;
			
			if(gen == 1){
				myTimer2.stop();
				drawBoxes(a);
				gen = 2;
			} else if(gen == 2){
				checkForRestart();
			} 	
		}
		
		function drawBoxes(s){
						
			// save path to parent
			mom = targ.parent;
			
			targ.alpha = .8;
						
			//max cells in row and total
			setMaxCells(16); 
			var gmax = 4; 
			
			for(var i = 0; i<maxCells; i++){
				
				var b = new Cell(i, w1, maxCells, gmax, startX, startY);
				mom.addChild(b);				
				icons.push(b);
				
			}
		}
		
		function checkForRestart(){
			
			if(icons.length > 1){
				// check if cells have been clicked on
				var m = icons.length -1;
				
				// remove cells from tracking array, if they're started to drop
				for(var i = 0; i < m; i++){
					// first, check to see that icons[i] is defined 
					if(icons[i]){
						var y1 = icons[i].y;
						var y2 = icons[i].xy[1];
						if(y1 != y2){ icons.splice(i, 1); }
					} 
				}
				
			} else {
				// all cells have started to drop, so set up restart button
				if(restart_btn){
					restartButtonShow();
				} else {
					restartButtonMake();
				}
			}
			
		}
		
		//----------------------------------------		
		
		function getMidX(){
			return targ.width/2;
		}
						
		function getMidY(){
			return targ.height/2;
		}
		
		function getMaxCells(){
			return this.maxCells;
		}
		
		function setMaxCells(c){
			this.maxCells = c;
		}
		
		//--
		function restartListener(event:MouseEvent){
			restartButtonHide();
			restartGrid();
		}
		
		function restartButtonMake(){
			restart_btn = new restartButton(200, 60, 100, 140);
			restart_btn.addEventListener(MouseEvent.MOUSE_UP, restartListener);						
			this.addChild(restart_btn);
		}
		
		function restartButtonHide(){
			restart_btn.visible = false;
		}
		
		function restartButtonShow(){
			restart_btn.visible = true;
		}
		
		function restartGrid(){
			gen = 1;
			myTimer.start();	
		}
		
		public function incGen(){
			if(gen > 2){
				gen = 0;
			} else {
				gen = gen + 1;
			}			
		}		
		
	}
}